%% PARAMETERS
clear all;  
InputDir = 'D:\ExternalBlue320\AiyagariBPPResults\ResultsJan2009\NobRho93\';

%%  LOAD IN FILES
rho = load([InputDir 'rho.txt']);

Mall = importdata([InputDir 'momresid_all.txt'],'\t',1);
for i = 1:size(Mall.data,2)
    Mall.(Mall.textdata{i}) = Mall.data(:,i);
end

Mbyyear = importdata([InputDir 'momresid_byyear.txt'],'\t',1);
for i = 1:size(Mbyyear.data,2)
    Mbyyear.(Mbyyear.textdata{i}) = Mbyyear.data(:,i);
end

M2_33 = importdata([InputDir 'momresid_2_33.txt'],'\t',1);
for i = 1:size(M2_33.data,2)
    M2_33.(M2_33.textdata{i}) = M2_33.data(:,i);
end

M3_33 = importdata([InputDir 'momresid_3_33.txt'],'\t',1);
for i = 1:size(M3_33.data,2)
    M3_33.(M3_33.textdata{i}) = M3_33.data(:,i);
end

% lifecycle = importdata([InputDir 'lifecycleprofiles.txt'],'\t',1);
% for i = 1:size(lifecycle.data,2)
%     lifecycle.(lifecycle.textdata{i}) = lifecycle.data(:,i);
% end

%% CALCULATE INSURANCE COEFFICIENTS - BY YEAR
Mbyyear.COVepsDcr = Mbyyear.epsDcr - Mbyyear.eps .* Mbyyear.Dcr;
Mbyyear.VAReps = Mbyyear.eps2-Mbyyear.eps.^2;
Mbyyear.COVetaDcr = Mbyyear.etaDcr - Mbyyear.eta .* Mbyyear.Dcr;
Mbyyear.VAReta = Mbyyear.eta2-Mbyyear.eta.^2;
Mbyyear.COVDcrFDyr = Mbyyear.DcrFDyr - Mbyyear.Dcr.* Mbyyear.FDyr;
Mbyyear.COVDyrFDyr = Mbyyear.DyrFDyr - Mbyyear.Dyr.* Mbyyear.FDyr;
Mbyyear.COVDcrIVDyr = Mbyyear.DcrIVDyr - Mbyyear.Dcr.* Mbyyear.IVDyr;
Mbyyear.COVDyrIVDyr = Mbyyear.DyrIVDyr - Mbyyear.Dyr.* Mbyyear.IVDyr;

Mbyyear.COVDcrFDTyr = Mbyyear.DcrFDTyr - Mbyyear.Dcr.* Mbyyear.FDTyr;
Mbyyear.COVDTyrFDTyr = Mbyyear.DTyrFDTyr - Mbyyear.DTyr.* Mbyyear.FDTyr;
Mbyyear.COVDcrIVDTyr = Mbyyear.DcrIVDTyr - Mbyyear.Dcr.* Mbyyear.IVDTyr;
Mbyyear.COVDTyrIVDTyr = Mbyyear.DTyrIVDTyr - Mbyyear.DTyr.* Mbyyear.IVDTyr;

Mbyyear.phieps_true = 1- Mbyyear.COVepsDcr ./ Mbyyear.VAReps;
Mbyyear.phieta_true = 1- Mbyyear.COVetaDcr ./ Mbyyear.VAReta;   
Mbyyear.phieps_bpp = 1- Mbyyear.COVDcrFDyr./ Mbyyear.COVDyrFDyr;
Mbyyear.phieta_bpp = 1- Mbyyear.COVDcrIVDyr./ Mbyyear.COVDyrIVDyr;

Mbyyear.phieps_rho = 1- Mbyyear.COVDcrFDTyr./ Mbyyear.COVDTyrFDTyr;
Mbyyear.phieta_rho = 1- Mbyyear.COVDcrIVDTyr./ Mbyyear.COVDTyrIVDTyr;

%% CALCULATE INSURANCE COEFFICIENTS - OVERALL TRUE
M2_33.COVepsDcr = M2_33.epsDcr - M2_33.eps .* M2_33.Dcr;
M2_33.VAReps = M2_33.eps2-M2_33.eps.^2;
M2_33.phieps_true = 1- M2_33.COVepsDcr ./ M2_33.VAReps;

M3_33.COVetaDcr = M3_33.etaDcr - M3_33.eta .* M3_33.Dcr;
M3_33.VAReta = M3_33.eta2-M3_33.eta.^2;
M3_33.phieta_true = 1- M3_33.COVetaDcr ./ M3_33.VAReta;   

Mall.COVepsDcr = Mall.epsDcr - Mall.eps .* Mall.Dcr;
Mall.VAReps = Mall.eps2-Mall.eps.^2;
Mall.phieps_true = 1- Mall.COVepsDcr ./ Mall.VAReps;

Mall.COVetaDcr = Mall.etaDcr - Mall.eta .* Mall.Dcr;
Mall.VAReta = Mall.eta2-Mall.eta.^2;
Mall.phieta_true = 1- Mall.COVetaDcr ./ Mall.VAReta;   

%% CALCULATE INSURANCE COEFFICIENTS - OVERALL BPP
Mall.COVDcrFDyr = Mall.DcrFDyr - Mall.Dcr.* Mall.FDyr;
Mall.COVDyrFDyr = Mall.DyrFDyr - Mall.Dyr.* Mall.FDyr;
Mall.phieps_bpp = 1- Mall.COVDcrFDyr./ Mall.COVDyrFDyr;

M2_33.COVDcrFDyr = M2_33.DcrFDyr - M2_33.Dcr.* M2_33.FDyr;
M2_33.COVDyrFDyr = M2_33.DyrFDyr - M2_33.Dyr.* M2_33.FDyr;
M2_33.phieps_bpp = 1- M2_33.COVDcrFDyr./ M2_33.COVDyrFDyr;

Mall.COVDcrIVDyr = Mall.DcrIVDyr - Mall.Dcr.* Mall.IVDyr;
Mall.COVDyrIVDyr = Mall.DyrIVDyr - Mall.Dyr.* Mall.IVDyr;
Mall.phieta_bpp = 1- Mall.COVDcrIVDyr./ Mall.COVDyrIVDyr;

M3_33.COVDcrIVDyr = M3_33.DcrIVDyr - M3_33.Dcr.* M3_33.IVDyr;
M3_33.COVDyrIVDyr = M3_33.DyrIVDyr - M3_33.Dyr.* M3_33.IVDyr;
M3_33.phieta_bpp = 1- M3_33.COVDcrIVDyr./ M3_33.COVDyrIVDyr;


%% CALCULATE INSURANCE COEFFICIENTS - OVERALL BPP CORRECTED FOR RHO
Mall.COVDcrFDTyr = Mall.DcrFDTyr - Mall.Dcr.* Mall.FDTyr;
Mall.COVDTyrFDTyr = Mall.DTyrFDTyr - Mall.DTyr.* Mall.FDTyr;
Mall.phieps_rho = 1- Mall.COVDcrFDTyr./ Mall.COVDTyrFDTyr;

M2_33.COVDcrFDTyr = M2_33.DcrFDTyr - M2_33.Dcr.* M2_33.FDyr;
M2_33.COVDTyrFDTyr = M2_33.DTyrFDTyr - M2_33.DTyr.* M2_33.FDTyr;
M2_33.phieps_rho = 1- M2_33.COVDcrFDTyr./ M2_33.COVDTyrFDTyr;

Mall.COVDcrIVDTyr = Mall.DcrIVDTyr - Mall.Dcr.* Mall.IVDTyr;
Mall.COVDTyrIVDTyr = Mall.DTyrIVDTyr - Mall.DTyr.* Mall.IVDTyr;
Mall.phieta_rho = 1- Mall.COVDcrIVDTyr./ Mall.COVDTyrIVDTyr;

M3_33.COVDcrIVDTyr = M3_33.DcrIVDTyr - M3_33.Dcr.* M3_33.IVDTyr;
M3_33.COVDTyrIVDTyr = M3_33.DTyrIVDTyr - M3_33.DTyr.* M3_33.IVDTyr;
M3_33.phieta_rho = 1- M3_33.COVDcrIVDTyr./ M3_33.COVDTyrIVDTyr;

%% DISPLAY OVERALL COEFFICIENTS

disp(['true permanent insurance coeff is ' num2str(M3_33.phieta_true)]); 
disp(['bpp correct permanent insurance coeff is ' num2str(M3_33.phieta_rho)]); 
disp(['bpp misspecified permanent insurance coeff is ' num2str(M3_33.phieta_bpp)]); 
disp(['true transitory insurance coeff is ' num2str(M2_33.phieps_true)]); 
disp(['bpp correct transitory insurance coeff is ' num2str(M2_33.phieps_rho)]); 
disp(['bpp misspecified transitory insurance coeff is ' num2str(M2_33.phieps_bpp)]); 

figure(1);
subplot(1,2,1),plot(Mbyyear.year, [Mbyyear.phieta_true Mbyyear.phieta_rho Mbyyear.phieta_bpp], 'LineWidth', 1.5);
ylim([-0.1 1]);
title('Permanent Shock');

subplot(1,2,2),plot(Mbyyear.year, [Mbyyear.phieps_true Mbyyear.phieps_rho Mbyyear.phieps_bpp], 'LineWidth', 1.5);
ylim([-0.1 1]);
title('Transitory Shock')

save([InputDir 'inscoef.mat'])
