# delimit;
set more 1;

clear;
set mem 500m;
set logtype text;

use Simulations_long.dta;

gen lc = log(csim);
gen ly = log(ysim);
gen lypre = log(ypresim);
gen lyav = log(yavsim);
gen la	= log(asim);
gen eta = D.zsim;
gen eps = esim;
gen n0ass = asim<=0;

collapse 	(mean) Ey = ysim Eypre = ypresim Eyav = yavsim Em = msim Ea = asim Ec = csim FracNeg0 = n0ass
			(sd) Vly = ly Vlypre=lypre Vlc=lc Vlyav=lyav Vla=la Veta = eta Veps = eps
			,by(year) fast;
			
			
foreach var in Vly Vlypre Vlc Vlyav Veta Veps{;
	replace `var' = `var'^2;
};


sort year;
outsheet using lifecycleprofiles.txt, replace;