# delimit;
set more 1;

clear;
set mem 500m;
set logtype text;


use Simulations_long.dta;

local lpretax = $pretax;
if (`lpretax' == 1) {;
	cap drop ysim;
	rename ypresim ysim;
};

keep if year<35;

xi i.year , prefix(D);
foreach v in c y{;
	gen `v' = log(`v'sim);
	reg `v' Dyear*;
	predict `v'r if e(sample), res ;
};	

foreach var of varlist c y cr yr{;
	gen D`var' = D.`var';
	gen DT`var' = `var' - $rho*L.`var';
};

gen eta = zsim - $rho*L.zsim;
gen eps = esim;
gen eta2 = eta^2;
gen eps2 = eps^2;

gen FDyr = F.Dyr;
gen IVDyr = F.Dyr +Dyr + L.Dyr;
gen DcrFDyr = Dcr*FDyr;
gen DyrFDyr = Dyr*FDyr;
gen epsDcr = eps*Dcr;
gen etaDcr = eta*Dcr;
gen DcrIVDyr = Dcr*IVDyr;
gen DyrIVDyr = Dyr*IVDyr;

gen FDTyr = F.DTyr;
gen IVDTyr = FDTyr +$rho*DTyr +(($rho)^2)*L.DTyr;
gen DcrFDTyr = Dcr*FDTyr;
gen DTyrFDTyr = DTyr*FDTyr;
gen DcrIVDTyr = Dcr*IVDTyr;
gen DTyrIVDTyr = DTyr*IVDTyr;

preserve;
collapse eta eta2 eps eps2 Dyr Dcr FDyr IVDyr DcrFDyr DyrFDyr epsDcr etaDcr DcrIVDyr DyrIVDyr DTyr FDTyr IVDTyr DcrFDTyr DTyrFDTyr DcrIVDTyr DTyrIVDTyr, fast;
outsheet using momresid_all.txt, replace;
restore, preserve;
collapse eta eta2 eps eps2 Dyr Dcr FDyr IVDyr DcrFDyr DyrFDyr epsDcr etaDcr DcrIVDyr DyrIVDyr DTyr FDTyr IVDTyr DcrFDTyr DTyrFDTyr DcrIVDTyr DTyrIVDTyr if year>=3 & year<=33, fast;
outsheet using momresid_3_33.txt, replace;
restore, preserve;
collapse eta eta2 eps eps2 Dyr Dcr FDyr IVDyr DcrFDyr DyrFDyr epsDcr etaDcr DcrIVDyr DyrIVDyr DTyr FDTyr IVDTyr DcrFDTyr DTyrFDTyr DcrIVDTyr DTyrIVDTyr if year>=2 & year<=33, fast;
outsheet using momresid_2_33.txt, replace;
restore, preserve;
collapse eta eta2 eps eps2 Dyr Dcr FDyr IVDyr DcrFDyr DyrFDyr epsDcr etaDcr DcrIVDyr DyrIVDyr DTyr FDTyr IVDTyr DcrFDTyr DTyrFDTyr DcrIVDTyr DTyrIVDTyr, by(year) fast;
outsheet using momresid_byyear.txt, replace;
