# delimit;
set more 1;

clear;
set mem 500m;
set logtype text;


use Simulations_long.dta;

local lpretax = $pretax;
if (`lpretax' == 1) {;
	cap drop ysim;
	rename ypresim ysim;
};

keep if year<35;

xi i.year , prefix(D);
foreach v in c y{;
	gen `v' = log(`v'sim);
	reg `v' Dyear*;
	predict `v'r if e(sample), res ;
};	
drop Dyear*;

iis id;
tsset id year;
foreach var of varlist cr yr{;
	gen D`var' = D.`var';
};

gen eta = D.zsim;
gen eps = esim;
gen eta2 = eta^2;
gen eps2 = eps^2;
gen bet = ssim;
gen bet2 = bet^2;


gen FDyr = F.Dyr;
gen IVDyr = F.Dyr +Dyr + L.Dyr;
gen DcrFDyr = Dcr*FDyr;
gen DyrFDyr = Dyr*FDyr;
gen epsDcr = eps*Dcr;
gen etaDcr = eta*Dcr;
gen DcrIVDyr = Dcr*IVDyr;
gen DyrIVDyr = Dyr*IVDyr;
gen betDcr = bet*Dcr;


preserve;
collapse eta eta2 eps eps2 Dyr Dcr FDyr IVDyr DcrFDyr DyrFDyr epsDcr etaDcr DcrIVDyr DyrIVDyr bet bet2 betDcr, fast;
outsheet using momresid_all.txt, replace;
restore, preserve;
collapse eta eta2 eps eps2 Dyr Dcr FDyr IVDyr DcrFDyr DyrFDyr epsDcr etaDcr DcrIVDyr DyrIVDyr bet bet2 betDcr if year>=3 & year<=33, fast;
outsheet using momresid_3_33.txt, replace;
restore, preserve;
collapse eta eta2 eps eps2 Dyr Dcr FDyr IVDyr DcrFDyr DyrFDyr epsDcr etaDcr DcrIVDyr DyrIVDyr bet bet2 betDcr if year>=2 & year<=33, fast;
outsheet using momresid_2_33.txt, replace;
restore,preserve;
collapse eta eta2 eps eps2 Dyr Dcr FDyr IVDyr DcrFDyr DyrFDyr epsDcr etaDcr DcrIVDyr DyrIVDyr bet bet2 betDcr, by(year) fast;
outsheet using momresid_byyear.txt, replace;

