# delimit;
set more 1;

clear;
set mem 400m;
set logtype text;


global Twork 35;
global Twork1 34;
global Ttot 70;
global Ttot1 71;


*create data set to append files to;
clear;
set obs $Nsim;
gen id = _n;
sort id;
compress;
save Simulations.dta, replace;

*read in files from fortran;

foreach var in ysim csim ypresim trsim xsim{; *;
    clear;
    insheet using `var'.txt;
    gen id = _n;
    forvalues i = 1/$Ttot{;
        rename v`i' `var'`i';
    }; 
    sort id;
    compress;
    merge id using Simulations.dta;
    tab _merge;
    drop _merge;
    sort id;
	save Simulations.dta, replace;
*	erase `var'.txt;
};

foreach var in esim esimI zsim zsimI tsim yavsim msim msimI{; *;
    clear;
    insheet using `var'.txt;
    gen id = _n;
    forvalues i = 1/$Twork{;
        rename v`i' `var'`i';
    }; 
    sort id;
    compress;
    merge id using Simulations.dta;
    tab _merge;
    drop _merge;
    sort id;
	save Simulations.dta, replace;
*	erase `var'.txt;
};

clear;
insheet using asim.txt;
gen id = _n;

forvalues i = 1/$Ttot1{;
    rename v`i' asim`i';
}; 
sort id;
compress;
merge id using Simulations.dta;
tab _merge;
drop _merge;
sort id;
save Simulations.dta, replace;
*erase asim.txt;

use Simulations.dta, clear;
reshape long ysim ypresim csim asim esim zsim esimI zsimI trsim xsim tsim msim msimI yavsim, i(id) j(year);
compress;
iis id;
tsset id year;
*saveold Simulations_long.dta, replace;
save Simulations_long.dta, replace;



